structure Personen =
  struct
    datatype person = a | b | c | d | e | f | g | h | i | j | k 
                    | l | m | n | p | q | r | s | t | u | v | w 

    structure Q = 
      Quantoren(struct type obj = person
                       val objects = [a,b,c,d,e,f,g,h,i,j,k,l,m,n,p,q,r,s,t] 
                end)
 
    (* Werte der verallgemeinerten Quantoren ueber Personen *) 

    val ein   = Q.exists
    val jeder = Q.forall
    val der   = Q.thefirst

    val alle    = Q.forall_2_2
    val einige  = Q.exists_2_2
    val je_zwei = Q.forall_1_2
    val ein_paar = Q.exists_1_2

    (* Werte der Eigennamen und der ein- und zweistelligen Nomen *)

    val Anna = a
    val Dieter = d
    val Emil = e
    val Maria = m

    fun Frau(a | b | c | g | h | i | m | n | s | t | u) = true 
      | Frau(_) = false                 

    fun Mann(d | e | f | j | k | l | p | q | r | v | w) = true 
      | Mann(_) = false

    fun Student(u | v | w) = false
      | Student(_) = true

    fun Bruder((d,e) | (e,d)) = true 
      | Bruder(_,_) = false

    fun Nachbar((a,d) | (a,e) | (b,a) | (b,c) | (d,e)) = true
      | Nachbar(_,_) = false

    (* Werte der ein- und zweistelligen Verben *)

    fun arbeitet(a | b | c | d | e) = true
      | arbeitet(_) = false
    
    fun kennt((a,e) | (a,m) | (e,a) | (m,e)) = true
      | kennt(x,y) = if x=y then true else false

    fun liebt((e,m) | (a,e) | (d,e) | (e,d)) = true
      | liebt(x,y) = false
    
    fun ist(x,y) = if x=y then true else false

    val toString = (fn a => "a" | b => "b" | c => "c" 
                     | d => "d" | e => "e" | m => "m"
                       | _ => "some person")
  end

