structure P = D.P

structure Tokens = Tokens
structure Interface = Interface

open Interface

type pos = Interface.pos
type svalue = Tokens.svalue
type ('a,'b) token = ('a,'b) Tokens.token
type lexresult = (svalue,pos) token

fun eof() = Tokens.EOF(!line,!line)
fun makeInt (s : string) = s

%%  
%header (functor NL_LexFun(structure Tokens: NL__TOKENS
                           structure Interface: INTERFACE) : LEXER);
%full 

idchars=[0-9]|[_&+/@|#*`'><];   
alpha=[a-zA-Z];
comment=%(.*)\n;
whitespace=[\t\ ]*;
%%
<INITIAL>{whitespace} => (lex());
<INITIAL>"Der"    => (Tokens.DET(!line,!line));
<INITIAL>"Die"    => (Tokens.DET(!line,!line));
<INITIAL>"Jede"   => (Tokens.JEDER(!line,!line));
<INITIAL>"Jeder"  => (Tokens.JEDER(!line,!line));
{comment}  => (next_line(); lex());
\n         => (next_line(); lex());
"."        => (Tokens.PUNKT(!line,!line));
"und"      => (Tokens.UND(!line,!line));
"oder"     => (Tokens.ODER(!line,!line));
"nicht"    => (Tokens.NICHT(!line,!line));
"der"      => (Tokens.DET(!line,!line));
"die"      => (Tokens.DET(!line,!line));
"ist"      => (Tokens.IST(!line,!line));
"Anna"     => (Tokens.pn(P.Anna,!line,!line));
"Dieter"   => (Tokens.pn(P.Dieter,!line,!line));
"Emil"     => (Tokens.pn(P.Emil,!line,!line));
"Maria"    => (Tokens.pn(P.Maria,!line,!line));
"Mann"     => (Tokens.n(P.Mann,!line,!line));
"Frau"     => (Tokens.n(P.Frau,!line,!line));
"Student"  => (Tokens.n(P.Student,!line,!line));
"arbeitet" => (Tokens.ivl(P.arbeitet,!line,!line));
"kennt"    => (Tokens.tv(P.kennt,!line,!line));
"liebt"    => (Tokens.tv(P.liebt,!line,!line));
"jede"     => (Tokens.JEDER(!line,!line));
"jeder"    => (Tokens.JEDER(!line,!line));
"eine"     => (Tokens.EIN(!line,!line));
"ein"      => (Tokens.EIN(!line,!line));
"alle"     => (Tokens.ALLE(!line,!line));
"einige"   => (Tokens.EINIGE(!line,!line));
"sich"     => (Tokens.refl(!line,!line));
"einander" => (Tokens.rezi(!line,!line));
"Nachbarn" => (Tokens.n2(P.Nachbar,!line,!line));  
"Brder"   => (Tokens.n2(P.Bruder,!line,!line));  
"Mnner"   => (Tokens.n(P.Mann,!line,!line));
"Frauen"   => (Tokens.n(P.Frau,!line,!line));
"Studenten"  => (Tokens.n(P.Student,!line,!line));
"kennen"   => (Tokens.tv(P.kennt,!line,!line));
"lieben"   => (Tokens.tv(P.liebt,!line,!line));
"sind"     => (Tokens.SIND(!line,!line));
.          => (error ("ignoring illegal character " ^ yytext,
                      !line,!line); lex());

